#include <sys/mman.h>
#include "sharedbuf.h"

void* alloc_shared_buffer(size_t size) {
   size_t nbytes = sizeof(size_t) + size;
   void* buffer = mmap(0, nbytes, PROT_READ|PROT_WRITE,
		     MAP_SHARED|MAP_ANON, -1, 0);
   if (buffer == (void*) MAP_FAILED) return 0;
   *(size_t*)buffer = nbytes;
   return (void*)((size_t *) buffer + 1);
}

void free_shared_buffer(void* buffer) {
   size_t* start = (size_t *) buffer - 1;
   size_t nbytes = *start;
   munmap(start, nbytes);
}
